unit hiPrinter;

interface

uses Kol,Share,Debug,KOLPageSetupDialog,KOLPrinters,Windows;

{$I share.inc}

type
  THIPrinter = class(TDebug)
   private
    PageSetupDialog1: TKOLPageSetupDialog;
    FSetup:boolean;
   public
    _data_RichEdit:THI_Event;
    _data_Text:THI_Event;
    _event_onPrint:THI_Event;

    constructor Create;
    procedure _work_doSettings(var _Data:TData; Index:word);
    procedure _work_doPrint(var _Data:TData; Index:word);
    procedure _var_Context(var _Data:TData; Index:word);
  end;

implementation

constructor THIPrinter.Create;
begin
   inherited;
   PageSetupDialog1 := NewPageSetupDialog(Applet.Children[0],[]);
end;

procedure THIPrinter._work_doSettings;
begin
  PageSetupDialog1.SetMinMargins(500,500,500,500); //set min margins user can select
  PageSetupDialog1.SetMargins(1500,1500,1500,1500); //set initial margins in dialog
  PageSetupDialog1.Advanced := 1;
  if PageSetupDialog1.Execute then
   begin
    FSetup := true;
   end;
end;

procedure THIPrinter._work_doPrint;
var re:PControl;
   dt:TData;
begin
   with Printer{$ifndef F_P}^{$endif} do begin
      if FSetup then begin
         Assign(PageSetupDialog1.Info);
         AssignMargins(PageSetupDialog1.GetMargins,mgMillimeters);//assign selected marins to printer
      end;
      Title := 'Printing RichEdit test with selected printer...';
      if System.Assigned(_data_Text.Event) or not System.Assigned(_data_RichEdit.Event) then begin
         BeginDoc;
         WriteLn(ReadString(_Data,_data_Text,''));
         SetMapMode(Printer.Handle, MM_HIMETRIC);
//         SetMapMode(Printer.Handle, MM_TEXT);
         _hi_OnEvent(_event_onPrint, Handle);
         EndDoc;
      end else begin
         dt := ReadData(_Data,_data_RichEdit,nil);
         if Dt.sdata = 'RichEdit' then begin
            re := pointer(Dt.idata);
            RE_Print(re);
         end;
      end;
   end;
end;

procedure THIPrinter._var_Context;
begin
  dtInteger(_Data,Printer.Handle);
end;

end.